2 GOSUB 500
10 PRINT:PRINT"    VHF/UHF PROPOGATION PROGRAM"
12 PRINT:PRINT"         V 1.0 1984 WA9GFR"
14 PRINT:PRINT"        MODIFIED FOR IBM PC"
16 PRINT:PRINT"              WA2TIF"
30 PRINT:PRINT
50 PRINT"     PROGRAM WILL CALCULATE EXPECTED RANGES FOR VHF(100-175 MHZ)"
52 PRINT"     AND UHF (225-500 MHZ) FREQUENCIES. APPROXIMATE DYNAMIC RANGE IS"
54 PRINT"     FOR PATH LOSSES OF 125 TO 200 DB, COVERING MOST APPLICATIONS FOR"
56 PRINT"     RCVR SENS .5 TO 10 MICROVOLTS AND XMTR POWER OF 1 TO 1000 WATTS."
58 PRINT"     PROGRAM COVERS ANT HEIGHTS FROM 25 FT TO 5000 FT."
60 PRINT:PRINT"     PROGRAM DEFAULTS TO RCVR SENS AND XMTR PWR IN DBM. WOULD"
62 PRINT"     YOU RATHER WORK WITH MICROVOLTS AND WATTS? (Y=YES)":INPUT D$
100 CLS:PRINT "PRESS (V) FOR VHF OR (U) FOR UHF":PRINT
102 INPUT F$
104 IF F$ ="V" THEN PRINT "ENTERING VHF DATA":GOSUB 2000:GOTO 200
106 IF F$ ="U" THEN PRINT "ENTERING UHF DATA":GOSUB 3000:GOTO 200
108 GOTO 102
199 :
200 PRINT:GOSUB 600: REM SELECT FREQUENCY
205 PRINT: GOSUB 700: REM SELECT XMTR PWR & RCVR SENS
210 PRINT: GOSUB 900: REM SELECT ANT GAINS
215 PRINT: GOSUB 800: REM SELECT ANT HEIGHTS
220 :
300 CLS:PRINT F$"HF PROPOGATION: FREQ="F"MHZ
302 PRINT:PRINT"TRANSMITTER POWER OUT:"PD;TAB(30);"DBM"
304 PRINT TAB(22)PW;TAB(30)"WATTS
306 PRINT:PRINT"RECEIVER SENSITIVITY: "RD;TAB(30)"DBM"
308 PRINT TAB(22)RM;TAB(30)"UV"
310 PRINT:PRINT"LOWER ANTENNA:"GL"DBI @"H1"FT
312 PRINT:PRINT"UPPER ANTENNA:"GU"DBI @"H2"FT
314 PRINT:PRINT"COAXIAL LINE LOSSES: "LL"DB
320 PL=PD-RD+GU+GL-LL
322 DF=PL-37-20*LOG(F)/LOG(10)
324 DF=10^(DF/20):DF=INT(DF+.5)
326 PRINT:PRINT PL"DB PATH"
328 PRINT"FREE PATH IN SPACE ="DF"MILES"
350 PL=PL-20*LOG(F/F1)/LOG(10):PRINT
352 IF PL<P1 THEN PRINT"RANGE NOT IN PROGRAM: <"S1"MILES"
354 IF PL<P1 THEN PRINT TAB(23)"<"D1"(NAUT MI)":GOTO 400
356 IF PL >P5 THEN PRINT "RANGE NOT IN PROGRAM: >"S5"MILES"
358 IF PL >P5 THEN PRINT TAB(23) ">"D5"(NAUT MI)":GOTO 400
360 IF PL>=P1 AND PL<P2 THEN DN=D1+(D2-D1)*(PL-P1)/(P2-P1)
362 IF PL>=P2 AND PL<P3 THEN DN=D2+(D3-D2)*(PL-P2)/(P3-P2)
364 IF PL>=P3 AND PL<P4 THEN DN=D3+(D4-D3)*(PL-P3)/(P4-P3)
366 IF PL>=P4 AND PL<P5 THEN DN=D4+(D5-D4)*(PL-P4)/(P5-P4)
368 DS=INT(DN*1.151+.5):DN=INT(DN+.5)
370 PRINT"MAXIMUM EXPECTED RANGE: "DS"MILES"
372 PRINT TAB(24) DN"(NAUT MI)"
400 PRINT:PRINT:PRINT LL$
402 PRINT" G=MODIFY ANT GAINS       R=RUN AGAIN"
404 PRINT"H=MODIFY ANT HEIGHTS
406 PRINT "X=MODIFY R/T SENS/PWR    Q=QUIT
408 PRINT "F= NEW FREQ (SAME BAND)";
410 INPUT A$
412 IF A$=" "THEN 410
414 PRINT:PRINT
415 IF A$="R" THEN 100
416 IF A$="Q" THEN 4000
418 IF A$="G" THEN GOSUB 900:GOTO 300
420 IF A$="H" THEN GOSUB 800:GOTO 300
422 IF A$="X" THEN GOSUB 700:GOTO 300
424 IF A$="F" THEN GOSUB 600:GOTO 300
426 GOTO 410
500 D$="N":DIM H$(7,7):DIM H(7)
502 H(1)=25:H(2)=50:H(3)=100:H(4)=500:H(5)=1000:H(6)=2000
504 H(7)=5000
508 LL$=" --------------------------------------"
510 RETURN
600 PRINT"FREQUENCY IN MHZ  ("FL"-"FU")";:INPUT F
602 IF F<FL OR F>FU THEN 600
604 RETURN
700 IF D$="Y" THEN INPUT "INPUT XMTR POWER (IN WATTS";PW:GOTO 710
702 INPUT"INPUT XMTR POWER (IN DBM)";PD
704 PW=(PD-30)/10:PW=10^PW
706 IF PW>=1 THEN PW=INT(PW*10+.5)/10:GOTO 720
708 IF PW<1 THEN PW= INT(PW*1000+.5)/1000:GOTO 720
710 PD=10*LOG(PW)/LOG(10)+30:PD=INT(PD*10+.5)/10
720 IF D$="Y" THEN INPUT"RCVR SENSITIVITY (IN MICRO-VOLTS)";RM:GOTO 730
722 INPUT"RCVR SENSITIVITY(IN DBM)";RD
723 IF RD>0 THEN PRINT"<1 MW IS A NEGATIVE NUMBER":GOTO 722
724 RM=(RD+107)/20:RM=10^RM
726 IF RM>=1 THEN RM =INT(RM*10+.5)/10:GOTO 740
728 IF RM<1 THEN RM=INT(RM*100+.5)/100:GOTO 740
730 RD=20*LOG(RM)/LOG(10)-107:RD=INT(RD*10+.5)/10
740 RETURN
800 REM ANTENNA HEIGHTS
802 PRINT CL$"CHOOSE ANTENNA HEIGHTS BY SELECTING"
804 PRINT"NUMBERS FROM THE FOLLOWING MENUE":PRINT:PRINT
806 PRINT"1 =   25'    6 =   2000'"
808 PRINT"2 =   50     7 =   5000'"
810 PRINT"3 =  100'"
812 PRINT"4 =  500`"
814 PRINT"5 = 1000'"
820 PRINT:PRINT
830 INPUT"SELECT HEIGHT OF LOWER ANTENNA";H1
832 INPUT"SELRCT HEIGHT OF UPPER ANTENNA";H2
834 IF H1<1 OR H2<1 OR H1>7 OR H2>7 THEN PRINT"NOT IN MENUE":GOTO 830
836 IF H1>H2 THEN PRINT"LOWER AND UPPER REVERSED":GOTO 830
840 H$=H$(H1,H2):H1=H(H1):H2=H(H2)
850 P1=VAL(MID$(H$,1,3)):D1=VAL(MID$(H$,4,3))
852 P2=VAL(MID$(H$,7,3)):D2=VAL(MID$(H$,10,3))
854 P3=VAL(MID$(H$,13,3)):D3=VAL(MID$(H$,16,3))
856 P4=VAL(MID$(H$,19,3)):D4=VAL(MID$(H$,22,3))
858 P5=VAL(MID$(H$,25,3)): D5=VAL(MID$(H$,28,3))
860 S1=INT(D1*1.151+.5)
862 S5=INT(D5*1.151+.5)
870 PRINT CL$:RETURN
900 INPUT"GAIN OF LOWER ANTENNA(IN DBI)";GL
902 INPUT"GAIN OF UPPER ANTENNA(IN DBI)";GU
904 INPUT"COAXIAL LINE LOSSES(IN DB)";LL
906 RETURN
2000 F1=125:FL=100:FU=175: REM VHF DATA
2005 H$(1,1)="140010160025170035176050225340
2010 H$(1,2)="135010160030170046175065225360
2015 H$(1,3)="130010160037170055175035225385
2020 H$(1,4)="117010162060170075175100225405
2025 H$(1,5)="113010165070169085173100225415
2030 H$(1,6)="105010158080170100175120225425
2035 H$(1,7)="100010140085170130177160218400
2080 H$( 2, 2)="125010155030165045170060210300
2085 H$(2,3)="120010150032165050175105210310"
2090 H$( 2, 4)="110010158060167080183180205300
2095 H$( 2, 5)="105010160075168100180170207320
2100 H$( 2, 6)="110030163090170120183200208340
2105 H$( 2, 7)="115050133085162125168140210370
2150 H$( 3, 3)="125015155045166065174120203280
2155 H$( 3, 4)="115020152060163080177160203300
2160 H$( 3, 5)="110020152070165100195260210355
2165 H$( 3, 6)="110030150080164110195275209360
2170 H$( 3, 7)="115060140100164135196300211400
2214 H$( 4, 4)="110030150080159095165120204330
2215 H$( 4, 4)="110030150080159095165120204330
2220 H$( 4, 5)="115045151090160110170155204340
2225 H$( 4, 6)="116060155110161125176200204350
2230 H$( 4, 7)="123100156145165165190295210420
2275 H$( 5, 5)="116065144090155110165140203340
2280 H$( 5, 6)="120080145110160135170180204360
2285 H$( 5, 7)="125120145140158160165180203380
2330 H$( 6, 6)="125100150130160150168180200350
2335 H$( 6, 7)="122130149160160180170220200375
2380 H$( 7, 7)="125165150195160210169240200400
2390 RETURN
3000 F1=300:FL=225:FU=500:REM UHF DATA
3005 H$(1,1)="142010170030178050182100225315
3010 H$(1,2)="136010150020170035178060220300
3015 H$(1,3)="130010150025170045176060215275
3020 H$(1,4)="125020168055176070185125210260
3025 H$(1,5)="120020165065175080185135210270
3030 H$(1,6)="127040145060170085177100215305
3035 H$(1,7)="127060140080174120178130210305
3080 H$(2,2)="132010155030166040175060215280
3085 H$(2,3)="125010150030164045175070213280
3090 H$(2,4)="120020165060170070175090210270
3095 H$(2,5)="120030165070171080175096210280
3100 H$(2,6)="120040137060167090173100210290
3105 H$(2,7)="125070140090170125176135210320
3150 H$(3,3)="120010140025160045170060205240
3155 H$(3,4)="118020160060170075183140210280
3160 H$(3,5)="120030160070167080173100205260
3165 H$(3,6)="122050155080168100175120210300
3170 H$(3,7)="130080155110170130175145210325
3215 H$(4,4)="120040155070165085175115205265
3220 H$(4,5)="125055153080167100175125210305
3225 H$(4,6)="125072157100170120180160210315
3230 H$(4,7)="128105160135170150178180210345
3275 H$(5,5)="124065160100171120177140210310
3280 H$(5,6)="127085160115170130178160206300
3285 H$(5,7)="130115160144170160177180210350
3330 H$(6,6)="128105149120166140176166210340
3335 H$(6,7)="132135159160170175177195210360
3380 H$(7,7)="132165165200175220180240205363
3610 RETURN
4000 END
